Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionLineChartView.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionLineChartView.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionLineChartView.cs	(revision 7989)
@@ -58,20 +58,4 @@
     }
 
-    private void UpdateTargetVariables() {
-      // populate combobox
-      targetVariableComboBox.Items.Clear();
-      if (Content != null) {
-        if (testPrognosisStart < Content.ProblemData.TestPartition.Start || testPrognosisStart >= Content.ProblemData.TestPartition.End) {
-          testPrognosisStart = Content.ProblemData.TestPartition.Start;
-        }
-        foreach (var targetVariable in Content.ProblemData.TargetVariables)
-          targetVariableComboBox.Items.Add(targetVariable);
-
-        targetVariableComboBox.SelectedIndex = 0;
-      }
-    }
-
-
-
     private void RedrawChart() {
       this.chart.Series.Clear();
@@ -79,6 +63,5 @@
         this.chart.ChartAreas[0].AxisX.Minimum = 0;
         this.chart.ChartAreas[0].AxisX.Maximum = Content.ProblemData.Dataset.Rows - 1;
-        string targetVariable = (string)targetVariableComboBox.SelectedItem;
-        int varIndex = Content.ProblemData.TargetVariables.ToList().IndexOf(targetVariable);
+        string targetVariable = Content.ProblemData.TargetVariable;
 
         this.chart.Series.Add(TARGETVARIABLE_SERIES_NAME);
@@ -94,9 +77,9 @@
           this.chart.Series[PROGNOSEDVALUES_TRAINING_SERIES_NAME].Points
             .DataBindXY(Content.ProblemData.TrainingIndizes.ToArray(),
-                        Content.PrognosedTrainingValues.SelectMany(x => x).Skip(varIndex).TakeEvery(Content.ProblemData.TargetVariables.Count()).ToArray());
+                        Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes.Take(1), Content.ProblemData.TrainingPartition.Size).SelectMany(x => x).ToArray());
         } else {
           this.chart.Series[PROGNOSEDVALUES_TRAINING_SERIES_NAME].Points
             .DataBindXY(Content.ProblemData.TrainingIndizes.ToArray(),
-                        Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes, 1).SelectMany(x => x.Single()).Skip(varIndex).TakeEvery(Content.ProblemData.TargetVariables.Count()).ToArray());
+                        Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes, 1).SelectMany(x => x).ToArray());
         }
         this.chart.Series[PROGNOSEDVALUES_TRAINING_SERIES_NAME].Tag = Content;
@@ -110,20 +93,11 @@
         this.chart.Series[PROGNOSEDVALUES_TEST_SERIES_NAME].ChartType = SeriesChartType.FastLine;
         if (prognosedValuesCheckbox.Checked) {
-          int offsetToStart = testPrognosisStart - Content.ProblemData.TestPartition.Start;
           this.chart.Series[PROGNOSEDVALUES_TEST_SERIES_NAME].Points
-            .DataBindXY(Content.ProblemData.TestIndizes.Skip(offsetToStart).ToArray(),
-                        Content.GetPrognosedValues(Enumerable.Range(testPrognosisStart, 1), Content.ProblemData.TestPartition.End - testPrognosisStart)
-                        .SelectMany(x => x.SelectMany(y => y))
-                        .Skip(varIndex)
-                        .TakeEvery(Content.ProblemData.TargetVariables.Count())
-                        .ToArray());
+            .DataBindXY(Content.ProblemData.TestIndizes.ToArray(),
+                        Content.GetPrognosedValues(Content.ProblemData.TestIndizes.Take(1), Content.ProblemData.TestPartition.Size).SelectMany(x => x).ToArray());
         } else {
           this.chart.Series[PROGNOSEDVALUES_TEST_SERIES_NAME].Points
             .DataBindXY(Content.ProblemData.TestIndizes.ToArray(),
-                        Content.GetPrognosedValues(Content.ProblemData.TestIndizes, 1)
-                        .SelectMany(x => x.Single())
-                        .Skip(varIndex)
-                        .TakeEvery(Content.ProblemData.TargetVariables.Count())
-                        .ToArray());
+                        Content.GetPrognosedValues(Content.ProblemData.TestIndizes, 1).SelectMany(x => x).ToArray());
         }
         this.chart.Series[PROGNOSEDVALUES_TEST_SERIES_NAME].Tag = Content;
@@ -159,9 +133,9 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      UpdateTargetVariables();
+      RedrawChart();
     }
 
     private void Content_ProblemDataChanged(object sender, EventArgs e) {
-      UpdateTargetVariables();
+      RedrawChart();
     }
     private void Content_ModelChanged(object sender, EventArgs e) {
@@ -212,7 +186,5 @@
               this.CreateAndAddStripLine("Training and Test", start, row, Color.FromArgb(40, Color.Green), Color.FromArgb(40, Color.Red), ChartHatchStyle.WideUpwardDiagonal);
               break;
-            default:
-              // should not happen
-              break;
+            default: throw new NotSupportedException();
           }
           curAttr = attr[row];
@@ -242,22 +214,18 @@
         }
       } else if (Content != null) {
-        string targetVariable = (string)targetVariableComboBox.SelectedItem;
-        int varIndex = Content.ProblemData.TargetVariables.ToList().IndexOf(targetVariable);
-
+        string targetVariable = Content.ProblemData.TargetVariable;
 
         IEnumerable<int> indizes = null;
         IEnumerable<double> predictedValues = null;
+
         switch (series.Name) {
           case PROGNOSEDVALUES_TRAINING_SERIES_NAME:
             indizes = Content.ProblemData.TrainingIndizes.ToArray();
-            predictedValues =
-              Content.PrognosedTrainingValues.SelectMany(x => x).Skip(varIndex).TakeEvery(
-                Content.ProblemData.TargetVariables.Count()).ToArray();
+            predictedValues = Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes.Take(1), Content.ProblemData.TrainingPartition.Size).First();
             break;
           case PROGNOSEDVALUES_TEST_SERIES_NAME:
             testPrognosisStart = Content.ProblemData.TestPartition.Start;
             indizes = Content.ProblemData.TestIndizes.ToArray();
-            predictedValues = Content.PrognosedTestValues.SelectMany(x => x).Skip(varIndex).TakeEvery(
-              Content.ProblemData.TargetVariables.Count()).ToArray();
+            predictedValues = Content.GetPrognosedValues(Content.ProblemData.TestIndizes.Take(1), Content.ProblemData.TestPartition.Size).First();
             break;
         }
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionPrognosedValuesView.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionPrognosedValuesView.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis.Views/3.4/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionPrognosedValuesView.cs	(revision 7989)
@@ -82,57 +82,46 @@
 
     private void UpdateEstimatedValues() {
-      if (InvokeRequired) Invoke((Action)UpdateEstimatedValues);
-      else {
-        StringMatrix matrix = null;
-        List<string> columnNames = new List<string>();
-        if (Content != null) {
-          columnNames.Add("Id");
+      if (InvokeRequired) {
+        Invoke((Action)UpdateEstimatedValues);
+        return;
+      }
+      if (Content == null) return;
 
-          string[,] values = new string[Content.ProblemData.Dataset.Rows, 1 + 3 * Content.ProblemData.TargetVariables.Count()];
-          foreach (var row in Enumerable.Range(0, Content.ProblemData.Dataset.Rows))
-            values[row, 0] = row.ToString();
+      var targetVariable = Content.ProblemData.TargetVariable;
+      StringMatrix matrix = null;
+      List<string> columnNames = new List<string>();
+      columnNames.Add("Id");
 
-          var allPrognosedTraining = Content.PrognosedTrainingValues.SelectMany(x=>x).ToArray();
-          var allPrognosedTest = Content.PrognosedTestValues.SelectMany(x => x).ToArray();
-
-          int i = 0;
-          int targetVariableIndex = 0;
-          foreach (var targetVariable in Content.ProblemData.TargetVariables) {
-            var prognosedTraining =
-              allPrognosedTraining.Skip(targetVariableIndex).TakeEvery(Content.ProblemData.TargetVariables.Count());
-            var prognosedTest =
-              allPrognosedTest.Skip(targetVariableIndex).TakeEvery(Content.ProblemData.TargetVariables.Count());
-
-            double[] target = Content.ProblemData.Dataset.GetDoubleValues(targetVariable).ToArray();
-
-            var prognosedTrainingEnumerator = prognosedTraining.GetEnumerator();
-            foreach (var row in Content.ProblemData.TrainingIndizes) {
-              prognosedTrainingEnumerator.MoveNext();
-              values[row, i + 2] = prognosedTrainingEnumerator.Current.ToString();
-            }
-
-            var prognosedTestEnumerator = prognosedTest.GetEnumerator();
-            foreach (var row in Content.ProblemData.TestIndizes) {
-              prognosedTestEnumerator.MoveNext();
-              values[row, i + 3] = prognosedTestEnumerator.Current.ToString();
-            }
-
-            foreach (var row in Enumerable.Range(0, Content.ProblemData.Dataset.Rows)) {
-              values[row, i + 1] = target[row].ToString();
-            }
-
-            columnNames.AddRange(new string[] { targetVariable + "(actual)", targetVariable + "(training)", targetVariable + "(test)" });
-            i += 3;
-            targetVariableIndex++;
-          } // foreach
+      string[,] values = new string[Content.ProblemData.Dataset.Rows, 4];
+      var prognosedTraining = Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes.Take(1), Content.ProblemData.TrainingPartition.Size).First();
+      var prognosedTest = Content.GetPrognosedValues(Content.ProblemData.TrainingIndizes.Take(1), Content.ProblemData.TestPartition.Size).First();
+      double[] target = Content.ProblemData.Dataset.GetDoubleValues(targetVariable).ToArray();
 
 
-          matrix = new StringMatrix(values);
-          matrix.ColumnNames = columnNames.ToArray();
-          matrix.SortableView = true;
+      foreach (var row in Enumerable.Range(0, Content.ProblemData.Dataset.Rows)) {
+        values[row, 0] = row.ToString();
+        values[row, 1] = target[row].ToString();
+      }
 
-        } // if
-        matrixView.Content = matrix;
+      var rowsEnumerator = Content.ProblemData.TrainingIndizes.GetEnumerator();
+      var prognosisEnumerator = prognosedTraining.GetEnumerator();
+      while (rowsEnumerator.MoveNext() & prognosisEnumerator.MoveNext()) {
+        var row = rowsEnumerator.Current;
+        var prognosis = prognosisEnumerator.Current;
+        values[row, 2] = prognosis.ToString();
       }
+
+      rowsEnumerator = Content.ProblemData.TestIndizes.GetEnumerator();
+      prognosisEnumerator = prognosedTest.GetEnumerator();
+      while (rowsEnumerator.MoveNext() & prognosisEnumerator.MoveNext()) {
+        var row = rowsEnumerator.Current;
+        var prognosis = prognosisEnumerator.Current;
+        values[row, 3] = prognosis.ToString();
+      }
+
+      columnNames.AddRange(new string[] { targetVariable + "(actual)", targetVariable + "(training)", targetVariable + "(test)" });
+      matrix = new StringMatrix(values);
+      matrix.ColumnNames = columnNames.ToArray();
+      matrix.SortableView = true;
     }
     #endregion
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 7989)
@@ -193,6 +193,5 @@
       if (values == null) throw new ArgumentException("The varialbe " + variableName + " is not a double variable.");
 
-      foreach (int index in rows)
-        yield return values[index];
+      return rows.Select(index => values[index]);
     }
 
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/DatasetExtensions.cs	(revision 7989)
@@ -20,24 +20,8 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Problems.DataAnalysis {
   public static class DatasetExtensions {
-    public static IEnumerable<double> GetVectorEnumerable(this Dataset ds, IEnumerable<string> targetVariables, IEnumerable<int> rows) {
-      var vars = targetVariables.ToArray();
-      var values = (from var in vars
-                    select ds.GetReadOnlyDoubleValues(var))
-        .ToArray();
-
-      foreach (var r in rows) {
-        for (int i = 0; i < values.Length; i++)
-          yield return values[i][r];
-      }
-    }
-
     public static IEnumerable<T> TakeEvery<T>(this IEnumerable<T> xs, int nth) {
       int i = 0;
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblemData.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblemData.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisProblemData.cs	(revision 7989)
@@ -33,5 +33,5 @@
   [Item("TimeSeriesPrognosisProblemData", "Represents an item containing all data defining a time series prognosis problem.")]
   public class TimeSeriesPrognosisProblemData : DataAnalysisProblemData, ITimeSeriesPrognosisProblemData {
-    protected const string TargetVariablesParameterName = "TargetVariables";
+    protected const string TargetVariableParameterName = "TargetVariable";
 
     #region default data
@@ -1540,5 +1540,5 @@
     private static readonly Dataset defaultDataset;
     private static readonly IEnumerable<string> defaultAllowedInputVariables;
-    private static readonly string[] defaultTargetVariables;
+    private static readonly string defaultTargetVariable;
 
     private static readonly TimeSeriesPrognosisProblemData emptyProblemData;
@@ -1551,5 +1551,5 @@
       defaultDataset.Name = "Mackey-Glass (t=17) Time Series Benchmark Dataset";
       defaultAllowedInputVariables = new List<string>() { "x" };
-      defaultTargetVariables = new string[] { "x" };
+      defaultTargetVariable = "x";
 
       var problemData = new TimeSeriesPrognosisProblemData();
@@ -1563,14 +1563,14 @@
       problemData.Parameters.Add(new FixedValueParameter<IntRange>(TrainingPartitionParameterName, "", (IntRange)new IntRange(0, 0).AsReadOnly()));
       problemData.Parameters.Add(new FixedValueParameter<IntRange>(TestPartitionParameterName, "", (IntRange)new IntRange(0, 0).AsReadOnly()));
-      problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariablesParameterName, new ItemSet<StringValue>()));
+      problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
       emptyProblemData = problemData;
     }
     #endregion
 
-    public ValueParameter<CheckedItemList<StringValue>> TargetVariablesParameter {
-      get { return (ValueParameter<CheckedItemList<StringValue>>)Parameters[TargetVariablesParameterName]; }
+    public ConstrainedValueParameter<StringValue> TargetVariableParameter {
+      get { return (ConstrainedValueParameter<StringValue>)Parameters[TargetVariableParameterName]; }
     }
-    public IEnumerable<string> TargetVariables {
-      get { return TargetVariablesParameter.Value.CheckedItems.Select(x => x.Value.Value); }
+    public string TargetVariable {
+      get { return TargetVariableParameter.Value.Value; }
     }
 
@@ -1592,22 +1592,17 @@
 
     public TimeSeriesPrognosisProblemData()
-      : this(defaultDataset, defaultAllowedInputVariables, defaultTargetVariables) {
+      : this(defaultDataset, defaultAllowedInputVariables, defaultTargetVariable) {
     }
 
-    public TimeSeriesPrognosisProblemData(Dataset dataset, IEnumerable<string> allowedInputVariables, IEnumerable<string> targetVariables)
+    public TimeSeriesPrognosisProblemData(Dataset dataset, IEnumerable<string> allowedInputVariables, string targetVariable)
       : base(dataset, allowedInputVariables) {
       var variables = InputVariables.Select(x => x.AsReadOnly()).ToList();
-      var targetVariablesList = new CheckedItemList<StringValue>(variables);
-      foreach (var targetVar in targetVariables) {
-        targetVariablesList.SetItemCheckedState(targetVariablesList.Single(x => x.Value == targetVar), true);
-      }
-      Parameters.Add(new FixedValueParameter<CheckedItemList<StringValue>>(TargetVariablesParameterName, targetVariablesList));
+      Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>(variables), variables.First(x => x.Value == targetVariable)));
       RegisterParameterEvents();
     }
 
     private void RegisterParameterEvents() {
-      TargetVariablesParameter.Value.CheckedItemsChanged += TargetVariableParameter_ValueChanged;
+      TargetVariableParameter.ValueChanged += new EventHandler(TargetVariableParameter_ValueChanged);
     }
-
     private void TargetVariableParameter_ValueChanged(object sender, EventArgs e) {
       OnChanged();
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolution.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolution.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolution.cs	(revision 7989)
@@ -21,5 +21,4 @@
 
 using System.Collections.Generic;
-using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -33,13 +32,7 @@
 
     [StorableConstructor]
-    protected TimeSeriesPrognosisSolution(bool deserializing)
-      : base(deserializing) {
-    }
-    protected TimeSeriesPrognosisSolution(TimeSeriesPrognosisSolution original, Cloner cloner)
-      : base(original, cloner) {
-    }
-    protected TimeSeriesPrognosisSolution(ITimeSeriesPrognosisModel model, ITimeSeriesPrognosisProblemData problemData)
-      : base(model, problemData) {
-    }
+    protected TimeSeriesPrognosisSolution(bool deserializing) : base(deserializing) { }
+    protected TimeSeriesPrognosisSolution(TimeSeriesPrognosisSolution original, Cloner cloner) : base(original, cloner) { }
+    protected TimeSeriesPrognosisSolution(ITimeSeriesPrognosisModel model, ITimeSeriesPrognosisProblemData problemData) : base(model, problemData) { }
 
     protected override void RecalculateResults() {
@@ -47,28 +40,6 @@
     }
 
-    public override IEnumerable<IEnumerable<double>> PrognosedTrainingValues {
-      get {
-        return GetPrognosedValues(ProblemData.TrainingIndizes.Take(1),
-          ProblemData.TrainingPartition.End - ProblemData.TrainingPartition.Start)
-          .First();
-      }
-    }
-    public override IEnumerable<IEnumerable<double>> PrognosedTestValues {
-      get {
-        return GetPrognosedValues(ProblemData.TestIndizes.Take(1),
-          ProblemData.TestPartition.End - ProblemData.TestPartition.Start)
-          .First();
-      }
-    }
-    public override IEnumerable<IEnumerable<IEnumerable<double>>> GetPrognosedValues(IEnumerable<int> rows, int horizon) {
+    public override IEnumerable<IEnumerable<double>> GetPrognosedValues(IEnumerable<int> rows, int horizon) {
       return Model.GetPrognosedValues(ProblemData.Dataset, rows, horizon);
-    }
-
-    protected override void OnProblemDataChanged() {
-      base.OnProblemDataChanged();
-    }
-
-    protected override void OnModelChanged() {
-      base.OnModelChanged();
     }
   }
Index: /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs
===================================================================
--- /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs	(revision 7988)
+++ /branches/HeuristicLab.TimeSeries/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/TimeSeriesPrognosis/TimeSeriesPrognosisSolutionBase.cs	(revision 7989)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Concurrent;
 using System.Collections.Generic;
 using System.Linq;
@@ -75,88 +74,86 @@
     }
 
-    public abstract IEnumerable<IEnumerable<double>> PrognosedTrainingValues { get; }
-    public abstract IEnumerable<IEnumerable<double>> PrognosedTestValues { get; }
-    public abstract IEnumerable<IEnumerable<IEnumerable<double>>> GetPrognosedValues(IEnumerable<int> rows, int horizon);
+    public abstract IEnumerable<IEnumerable<double>> GetPrognosedValues(IEnumerable<int> rows, int horizon);
 
     #region Results
-    public double[] TrainingMeanSquaredError {
-      get { return ((DoubleArray)this[TrainingMeanSquaredErrorResultName].Value).ToArray(); }
-      private set { this[TrainingMeanSquaredErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestMeanSquaredError {
-      get { return ((DoubleArray)this[TestMeanSquaredErrorResultName].Value).ToArray(); }
-      private set { this[TestMeanSquaredErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingMeanAbsoluteError {
-      get { return ((DoubleArray)this[TrainingMeanAbsoluteErrorResultName].Value).ToArray(); }
-      private set { this[TrainingMeanAbsoluteErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestMeanAbsoluteError {
-      get { return ((DoubleArray)this[TestMeanAbsoluteErrorResultName].Value).ToArray(); }
-      private set { this[TestMeanAbsoluteErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingRSquared {
-      get { return ((DoubleArray)this[TrainingSquaredCorrelationResultName].Value).ToArray(); }
-      private set { this[TrainingSquaredCorrelationResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestRSquared {
-      get { return ((DoubleArray)this[TestSquaredCorrelationResultName].Value).ToArray(); }
-      private set { this[TestSquaredCorrelationResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingRelativeError {
-      get { return ((DoubleArray)this[TrainingRelativeErrorResultName].Value).ToArray(); }
-      private set { this[TrainingRelativeErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestRelativeError {
-      get { return ((DoubleArray)this[TestRelativeErrorResultName].Value).ToArray(); }
-      private set { this[TestRelativeErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingNormalizedMeanSquaredError {
-      get { return ((DoubleArray)this[TrainingNormalizedMeanSquaredErrorResultName].Value).ToArray(); }
-      private set { this[TrainingNormalizedMeanSquaredErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestNormalizedMeanSquaredError {
-      get { return ((DoubleArray)this[TestNormalizedMeanSquaredErrorResultName].Value).ToArray(); }
-      private set { this[TestNormalizedMeanSquaredErrorResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingDirectionalSymmetry {
-      get { return ((DoubleArray)this[TrainingDirectionalSymmetryResultName].Value).ToArray(); }
-      private set { this[TrainingDirectionalSymmetryResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestDirectionalSymmetry {
-      get { return ((DoubleArray)this[TestDirectionalSymmetryResultName].Value).ToArray(); }
-      private set { this[TestDirectionalSymmetryResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingWeightedDirectionalSymmetry {
-      get { return ((DoubleArray)this[TrainingWeightedDirectionalSymmetryResultName].Value).ToArray(); }
-      private set { this[TrainingWeightedDirectionalSymmetryResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestWeightedDirectionalSymmetry {
-      get { return ((DoubleArray)this[TestWeightedDirectionalSymmetryResultName].Value).ToArray(); }
-      private set { this[TestWeightedDirectionalSymmetryResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingTheilsUStatisticLast {
-      get { return ((DoubleArray)this[TrainingTheilsUStatisticLastResultName].Value).ToArray(); }
-      private set { this[TrainingTheilsUStatisticLastResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestTheilsUStatisticLast {
-      get { return ((DoubleArray)this[TestTheilsUStatisticLastResultName].Value).ToArray(); }
-      private set { this[TestTheilsUStatisticLastResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingTheilsUStatisticMean {
-      get { return ((DoubleArray)this[TrainingTheilsUStatisticMeanResultName].Value).ToArray(); }
-      private set { this[TrainingTheilsUStatisticMeanResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestTheilsUStatisticMean {
-      get { return ((DoubleArray)this[TestTheilsUStatisticMeanResultName].Value).ToArray(); }
-      private set { this[TestTheilsUStatisticMeanResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TrainingTheilsUStatisticMovingAverage {
-      get { return ((DoubleArray)this[TrainingTheilsUStatisticMaResultName].Value).ToArray(); }
-      private set { this[TrainingTheilsUStatisticMaResultName].Value = new DoubleArray(value); }
-    }
-    public double[] TestTheilsUStatisticMovingAverage {
-      get { return ((DoubleArray)this[TestTheilsUStatisticMaResultName].Value).ToArray(); }
-      private set { this[TestTheilsUStatisticMaResultName].Value = new DoubleArray(value); }
+    public double TrainingMeanSquaredError {
+      get { return ((DoubleValue)this[TrainingMeanSquaredErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingMeanSquaredErrorResultName].Value).Value = value; }
+    }
+    public double TestMeanSquaredError {
+      get { return ((DoubleValue)this[TestMeanSquaredErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestMeanSquaredErrorResultName].Value).Value = value; }
+    }
+    public double TrainingMeanAbsoluteError {
+      get { return ((DoubleValue)this[TrainingMeanAbsoluteErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingMeanAbsoluteErrorResultName].Value).Value = value; }
+    }
+    public double TestMeanAbsoluteError {
+      get { return ((DoubleValue)this[TestMeanAbsoluteErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestMeanAbsoluteErrorResultName].Value).Value = value; }
+    }
+    public double TrainingRSquared {
+      get { return ((DoubleValue)this[TrainingSquaredCorrelationResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingSquaredCorrelationResultName].Value).Value = value; }
+    }
+    public double TestRSquared {
+      get { return ((DoubleValue)this[TestSquaredCorrelationResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestSquaredCorrelationResultName].Value).Value = value; }
+    }
+    public double TrainingRelativeError {
+      get { return ((DoubleValue)this[TrainingRelativeErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingRelativeErrorResultName].Value).Value = value; }
+    }
+    public double TestRelativeError {
+      get { return ((DoubleValue)this[TestRelativeErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestRelativeErrorResultName].Value).Value = value; }
+    }
+    public double TrainingNormalizedMeanSquaredError {
+      get { return ((DoubleValue)this[TrainingNormalizedMeanSquaredErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingNormalizedMeanSquaredErrorResultName].Value).Value = value; }
+    }
+    public double TestNormalizedMeanSquaredError {
+      get { return ((DoubleValue)this[TestNormalizedMeanSquaredErrorResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestNormalizedMeanSquaredErrorResultName].Value).Value = value; }
+    }
+    public double TrainingDirectionalSymmetry {
+      get { return ((DoubleValue)this[TrainingDirectionalSymmetryResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingDirectionalSymmetryResultName].Value).Value = value; }
+    }
+    public double TestDirectionalSymmetry {
+      get { return ((DoubleValue)this[TestDirectionalSymmetryResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestDirectionalSymmetryResultName].Value).Value = value; }
+    }
+    public double TrainingWeightedDirectionalSymmetry {
+      get { return ((DoubleValue)this[TrainingWeightedDirectionalSymmetryResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingWeightedDirectionalSymmetryResultName].Value).Value = value; }
+    }
+    public double TestWeightedDirectionalSymmetry {
+      get { return ((DoubleValue)this[TestWeightedDirectionalSymmetryResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestWeightedDirectionalSymmetryResultName].Value).Value = value; }
+    }
+    public double TrainingTheilsUStatisticLast {
+      get { return ((DoubleValue)this[TrainingTheilsUStatisticLastResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingTheilsUStatisticLastResultName].Value).Value = value; }
+    }
+    public double TestTheilsUStatisticLast {
+      get { return ((DoubleValue)this[TestTheilsUStatisticLastResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestTheilsUStatisticLastResultName].Value).Value = value; }
+    }
+    public double TrainingTheilsUStatisticMean {
+      get { return ((DoubleValue)this[TrainingTheilsUStatisticMeanResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingTheilsUStatisticMeanResultName].Value).Value = value; }
+    }
+    public double TestTheilsUStatisticMean {
+      get { return ((DoubleValue)this[TestTheilsUStatisticMeanResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestTheilsUStatisticMeanResultName].Value).Value = value; }
+    }
+    public double TrainingTheilsUStatisticMovingAverage {
+      get { return ((DoubleValue)this[TrainingTheilsUStatisticMaResultName].Value).Value; }
+      private set { ((DoubleValue)this[TrainingTheilsUStatisticMaResultName].Value).Value = value; }
+    }
+    public double TestTheilsUStatisticMovingAverage {
+      get { return ((DoubleValue)this[TestTheilsUStatisticMaResultName].Value).Value; }
+      private set { ((DoubleValue)this[TestTheilsUStatisticMaResultName].Value).Value = value; }
     }
     #endregion
